-----------------------------------------
-- Politecnico di Torino
-- Date: 12 December 2020
-- Project: Counter controller module
-- Written by: Mohammadmahdi Mohammadi
-----------------------------------------


-----------------------------
---- LIBRARY DECLERATIN -----
-----------------------------
library IEEE;
use IEEE.std_logic_1164.all; 


----------------
---- ENTITY ----
----------------
entity COUNTER_COTNROLLER is
	Port 	(COMMAND	:	in	std_logic_vector(1 downto 0);	   	-- State controller command 
			 MONITOR_IN	:	in	std_logic;							-- Signal to be monitored
			 CLEAR		:	out	std_logic;							-- CLEARS the counter
			 ENABLE		:	out	std_logic							-- Enables counting
			 );
end COUNTER_COTNROLLER;

------------------------
---- ARCHITECTURE 2 ----
------------------------
architecture COUNTER_COTNROLLER_BEH2 of COUNTER_COTNROLLER is

	type COUNTER_STATE is (RESET, COUNTING, IDLE);
	signal CURRENT_STATE : COUNTER_STATE;
	signal NEXT_STATE : COUNTER_STATE;

begin

 	P_OPC : process(COMMAND)		
	begin
		if	COMMAND="10" then
	        CURRENT_STATE <= RESET;
		elsif  COMMAND="01" then 
			CURRENT_STATE <= COUNTING;
		elsif  COMMAND="11" then 
			CURRENT_STATE <= IDLE;
		end if;
	end process P_OPC;

	P_NEXT_STATE : process(CURRENT_STATE,COMMAND,MONITOR_IN)
	begin
	
		case CURRENT_STATE is
			when RESET => 
				if COMMAND ="00" then
					NEXT_STATE <= RESET;
				elsif COMMAND ="10" then
					NEXT_STATE <= RESET;
				elsif COMMAND ="01" then
					NEXT_STATE <= COUNTING;
				elsif COMMAND ="11" then
					NEXT_STATE <= IDLE;					
				end if;
			when COUNTING => 
				if COMMAND ="00" then
					NEXT_STATE <= COUNTING;
				elsif COMMAND ="10" then
					NEXT_STATE <= RESET;
				elsif COMMAND ="01" then
					NEXT_STATE <= COUNTING;
				elsif COMMAND ="11" then
					NEXT_STATE <= IDLE;					
				end if;
			when IDLE => 
				if COMMAND ="00" then
					NEXT_STATE <= IDLE;
				elsif COMMAND ="10" then
					NEXT_STATE <= RESET;
				elsif COMMAND ="01" then
					NEXT_STATE <= COUNTING;
				elsif COMMAND ="11" then
					NEXT_STATE <= IDLE;					
				end if;
		end case;
		
	end process P_NEXT_STATE;

	
	P_OUTPUTS: process(CURRENT_STATE,MONITOR_IN)
	begin
		case CURRENT_STATE is
			when RESET => 
				ENABLE 	<= '0';	
				CLEAR 	<= '0';	
			when COUNTING => 
				ENABLE 	<= MONITOR_IN;	
				CLEAR 	<= '1';	
			when IDLE =>
				ENABLE 	<= '0';	
				CLEAR 	<= '1';	
		end case;	
	end process P_OUTPUTS;
	
	
end COUNTER_COTNROLLER_BEH2;





