-----------------------------------------
-- Politecnico di Torino
-- Date: 12 December 2020
-- Project: Counter subunit module
-- Written by: Mohammadmahdi Mohammadi
-----------------------------------------


-----------------------------
---- LIBRARY DECLERATIN -----
-----------------------------
library IEEE;
use IEEE.std_logic_1164.all; 


----------------
---- ENTITY ----
----------------
entity COUNTER_SUBUNIT is
	Port 	(COMMAND	:	In	std_logic_vector(1 downto 0);	   	-- State controller command 
			 MONITOR_IN	:	In	std_logic;							-- Signal to be monitored
			 CLK		:	In	std_logic;							-- CLOCK
			 COUNTER_OUT:	Out	std_logic_vector(31 downto 0)		-- Counter's output
			 );
end COUNTER_SUBUNIT;


----------------------
---- ARCHITECTURE ----
----------------------
architecture COUNTER_SUBUNIT_STR of COUNTER_SUBUNIT is

----------------------------
-- Components Declaration --
----------------------------

-- Counter controller module
component COUNTER_COTNROLLER is
	Port 	(COMMAND	:	in	std_logic_vector(1 downto 0);	-- State controller command 
			 MONITOR_IN	:	in	std_logic;						-- Signal to be monitored
			 CLEAR		:	out	std_logic;						-- CLEARS the counter
			 ENABLE		:	out	std_logic						-- Enables counting
			 );
end component COUNTER_COTNROLLER;

-- Generic Synchronus Counter
component SYNC_COUNTER is
	Generic (NBITS	:	integer := 32);							-- Number of counter output bits
	Port 	(CLK	:	In	std_logic;	   						-- Clock 
			 Clear	:	In	std_logic;	   						-- Active low clear 
			 EN		:	In	std_logic;	   						-- Enables counting 
			 QOUT	:	Out	std_logic_vector(NBITS-1 downto 0));-- Counter output
end component SYNC_COUNTER;

-------------------------
-- Signal Declaration ---
-------------------------
	signal Clear_s 	:std_logic;
	signal EN_s 	:std_logic;	
	

begin
	
	U1: COUNTER_COTNROLLER 	port map (COMMAND,MONITOR_IN,Clear_s,EN_s);
	
	U2: SYNC_COUNTER 		port map (CLK,Clear_s,EN_s,COUNTER_OUT);
	
end COUNTER_SUBUNIT_STR;





