-----------------------------------------
-- Politecnico di Torino
-- Date: 20 December 2020
-- Project: Counter subunit module ARRAY
-- Written by: Mohammadmahdi Mohammadi
-----------------------------------------

-----------------------------
---- LIBRARY DECLERATIN -----
-----------------------------
library IEEE;
use IEEE.std_logic_1164.all; 
use work.gpgpu_package.all;


----------------
---- ENTITY ----
----------------
entity COUNTER_SUBUNIT_ARRAY is
	Port 	(COMMAND_0	:	In	std_logic_vector(15 downto 0);	   	-- State controller command FIRST BIT
			 COMMAND_1	:	In	std_logic_vector(15 downto 0);	   	-- State controller command NEXT BIT
			 MONITOR_IN	:	In	std_logic_vector(15 downto 0);		-- Signal to be monitored
			 CLK		:	In	std_logic;							-- CLOCK
			 COUNTER_OUT:	Out BUS_ARRAY							-- ARRAY's output
			 );
end COUNTER_SUBUNIT_ARRAY;


----------------------
---- ARCHITECTURE ----
----------------------
architecture COUNTER_SUBUNIT_ARRAY_STR of COUNTER_SUBUNIT_ARRAY is

----------------------------
-- Components Declaration --
----------------------------

-- Counter SUBUNIT module
component COUNTER_SUBUNIT is
	Port 	(COMMAND	:	In	std_logic_vector(1 downto 0);	   	-- State controller command 
			 MONITOR_IN	:	In	std_logic;							-- Signal to be monitored
			 CLK		:	In	std_logic;							-- CLOCK
			 COUNTER_OUT:	Out	std_logic_vector(31 downto 0)		-- Counter's output
			 );
end component COUNTER_SUBUNIT;


begin
	
	COUNTER_ARRAY_GEN : for I in 15 downto 0 generate
	U1 : COUNTER_SUBUNIT
			port map (
						COMMAND(0)	=> COMMAND_0(I),			-- COMMAND first bit
						COMMAND(1)	=> COMMAND_1(I),			-- COMMAND second bit
						MONITOR_IN	=> MONITOR_IN(I),
						CLK			=> CLK,
						COUNTER_OUT => COUNTER_OUT(I)
					);
	end generate  COUNTER_ARRAY_GEN;
	
end COUNTER_SUBUNIT_ARRAY_STR;






