-----------------------------------------
-- Politecnico di Torino
-- Date: 18 April 2020
-- Project: D Flipflop component
-- Written by: Mohammadmahdi Mohammadi
-----------------------------------------


-----------------------------
---- LIBRARY DECLERATIN -----
-----------------------------
library IEEE;
use IEEE.std_logic_1164.all; 


----------------
---- ENTITY ----
----------------
entity FD is
	Port (D		:	In	std_logic;
		  CLK	:	In	std_logic;
		  RESET	:	In	std_logic;   -- active low reset 
		  EN	:	In	std_logic;
		  Q		:	Out	std_logic);
end FD;


----------------------
---- ARCHITECTURE ----
----------------------
architecture FD_SYNC of FD is
begin

	PSYNCH: process(CLK,RESET,EN)
	begin
		if CLK'event and CLK='1' then -- positive edge triggered:
			if RESET='0' then -- active high reset 
				Q <= '0';  -- reset
			else
				if EN='1' then -- active high enable 
					Q <= D; -- input is written on output
				end if;
			end if;
		end if;
	end process;

end FD_SYNC;




