-----------------------------------------
-- Politecnico di Torino
-- Date: 9 November 2020
-- Project: T Flipflop (complemented Q is not needed in this design)
-- Written by: Mohammadmahdi Mohammadi
-----------------------------------------


-----------------------------
---- LIBRARY DECLERATIN -----
-----------------------------
library IEEE;
use IEEE.std_logic_1164.all; 


----------------
---- ENTITY ----
----------------
entity T_FF is
	Port (	T		:	In	std_logic;
			CLK		:	In	std_logic;
			Clear	:	In	std_logic;   	-- Active Low 
			Q		:	Out	std_logic);
end T_FF;


----------------------
---- ARCHITECTURE ----
----------------------
architecture T_FF_BEH of T_FF is

	signal	Q_s	:	std_logic := '0'; 		-- To be used in the process

begin

	SYNCH: process(T,CLK,Clear)
	begin
		if CLK'event and CLK='1'	then 	-- Positive edge triggered:
			if Clear='0' then 				-- Active LOW 
				Q_s <= '0';  				-- Clear
			else
				if T='0' 			then
					Q_s <= Q_s; 			-- No change
				elsif T='1'			then
					Q_s <= not(Q_s); 		-- Toggle
				else
					Q_s <= 'Z'; 			-- Covering unexpected coditions
				end if;
			end if;
		end if;
	end process;
	
	Q <=  Q_s; 								-- Signal assignment

end T_FF_BEH;




