library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity TP_instructions is
	port(
		instruction_pointer_in : in  integer;
		num_instructions_out   : out integer;
		instruction_out        : out std_logic_vector(31 downto 0)
	);
end TP_instructions;

architecture arch of TP_instructions is
	constant TP_INSTRUCTIONS : integer := 42;

begin
	num_instructions_out <= TP_INSTRUCTIONS;

	process(instruction_pointer_in)
	begin
		case instruction_pointer_in is
-- PMU ACTIVATION
when 0	=> instruction_out <= x"70000800";   -- PMEVENT CNT0, CNT; 
when 1	=> instruction_out <= x"70002800";   -- PMEVENT CNT1, CNT; 
when 2 	=> instruction_out <= x"70004800";   -- PMEVENT CNT2, CNT; 
when 3 	=> instruction_out <= x"70006800";   -- PMEVENT CNT3, CNT; 
when 4 	=> instruction_out <= x"70008800";   -- PMEVENT CNT4, CNT; 
when 5 	=> instruction_out <= x"7000a800";   -- PMEVENT CNT5, CNT; 
when 6  => instruction_out <= x"7000c800";   -- PMEVENT CNT6, CNT; 
when 7  => instruction_out <= x"7000e800";   -- PMEVENT CNT7, CNT; 
when 8  => instruction_out <= x"70010800";   -- PMEVENT CNT8, CNT; 
when 9  => instruction_out <= x"70012800";   -- PMEVENT CNT9, CNT; 
when 10	=> instruction_out <= x"70014800";   -- PMEVENT CNT10, CNT;
when 11 => instruction_out <= x"70016800";   -- PMEVENT CNT11, CNT;
when 12 => instruction_out <= x"70018800";   -- PMEVENT CNT12, CNT;
when 13 => instruction_out <= x"7001a800";   -- PMEVENT CNT13, CNT;
when 14 => instruction_out <= x"7001c800";   -- PMEVENT CNT14, CNT;
when 15 => instruction_out <= x"7001e800";   -- PMEVENT CNT15, CNT;
-----------  
when 16 => instruction_out <= x"10004205";   -- MOV.U16 R0H, g [0x1].U16;
when 17 => instruction_out <= x"0023c780";
when 18 => instruction_out <= x"a0000005";   -- I2I.U32.U16 R1, R0L;
when 19 => instruction_out <= x"04000780";
when 20 => instruction_out <= x"60014c01";   -- IMAD.U16 R0, g [0x6].U16, R0H, R1;
when 21 => instruction_out <= x"00204780";
when 22 => instruction_out <= x"30020009";   -- SHL R2, R0, 0x2;
when 23 => instruction_out <= x"c4100780";
when 24 => instruction_out <= x"2102e800";   -- IADD32 R0, g [0x4], R2;
when 25 => instruction_out <= x"2102ea0c";   -- IADD32 R3, g [0x5], R2;
when 26 => instruction_out <= x"d00e0005";   -- GLD.U32 R1, global14[R0];
when 27 => instruction_out <= x"80c00780";
when 28 => instruction_out <= x"d00e0601";   -- GLD.U32 R0, global14[R3];
when 29 => instruction_out <= x"80c00780";
when 30 => instruction_out <= x"20008204";   -- IADD32 R1, R1, R0;
when 31 => instruction_out <= x"2102ec00";   -- IADD32 R0, g [0x6], R2;
when 32 => instruction_out <= x"d00e0005";   -- GST.U32 global14[R0], R1;
when 33 => instruction_out <= x"a0c00781"; 
-- PMU READ and WRITE
when 34 => instruction_out <= x"70001814";   -- PMEVENT CNT0, R5, IDL;
when 35 => instruction_out <= x"70003804";   -- PMEVENT CNT1, R1, IDL;
when 36 => instruction_out <= x"70005808";   -- PMEVENT CNT2, R2, IDL;
when 37 => instruction_out <= x"7001980c";   -- PMEVENT CNT12, R3, IDL;
when 38 => instruction_out <= x"70009810";   -- PMEVENT CNT4, R4, IDL;
when 39 => instruction_out <= x"70015000";   -- PMEVENT CNT10, RST;
-----------
when 40 => instruction_out <= x"30000003";   -- RET
when 41 => instruction_out <= x"00000780";
			when others => null;
		end case;
	end process;

end arch;




